#ifndef LIBWIISPRITE_GAMEWINDOW
#define LIBWIISRPITE_GAMEWINDOW

#include <stdlib.h>
#include <gccore.h>

#define DEFAULT_FIFO_SIZE (1024*1024)

//!libwiisprite namespace
namespace wsp{
	//!Basic rendering unit.
	class GameWindow{
		public:
			//!Constructor.
			GameWindow();
			//!Destructor.
			virtual ~GameWindow();

			//!Initialized the whole video subsystem.
			void InitVideo();
			//!Checks if the video subsystem is already initialized.
			//!\return true if initialized, false if not.
			bool IsInitialized() const;
			//!Sets the background clear color
			//!\param bgcolor is a GXColor containing r, g, b and a.
			void SetBackground(GXColor bgcolor);
			//!Finishes rendering.
			void Flush();
		protected:
		private:
			bool _initialized;
			void* _frameBuffer[2]; u32 _fb;
			GXRModeObj* _rmode;
			void* _gp_fifo;
	};
};

#endif
